Bug 240308 - Review Request: qt4-qwtplot3d - Providing essentially a bunch of 3D-widgets for programmers
Review Request: qt4-qwtplot3d - Providing essentially a bunch of 3D-widgets f...
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Chitlesh GOORAH
Fedora Package Reviews List
:
Depends On:
Blocks: 240373
  Show dependency treegraph
 
Reported: 2007-05-16 09:13 EDT by Frank Büttner
Modified: 2007-11-30 17:12 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-08-26 19:55:03 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Frank Büttner 2007-05-16 09:13:47 EDT
Spec URL: http://downloads.sourceforge.net/qsmartcard/qt4-qwtplot3d.spec?use_mirror=dfn
SRPM URL: http://downloads.sourceforge.net/qsmartcard/qt4-qwtplot3d-0.2.6-1FC5.src.rpm?use_mirror=dfn
Description:
QwtPlot3D is not a program, but a feature-rich Qt/OpenGL-based
C++ programming library, providing essentially a bunch of
3D-widgets for programmers.
Comment 1 Mamoru TASAKA 2007-05-16 10:51:06 EDT
https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=221163

* If you have a special reason to use qt4, not qt3, then
  the most file names should be renamed to avoid conflict
  of qt3 version qwtplot3d, or explicit conflict must be used.

* Otherwise, this bug must be closed as a duplicate of above.
Comment 2 Rex Dieter 2007-05-16 11:02:39 EDT
afaict, it looks like qwtplot3d can be built for/against both qt3/qt4.  If that
is the case, then Frank can/should work with the current maintainer of qwtplot3d
to get the qt4 bits built/included too.  

Both qt3/qt4 builds seem to use identical libnames, which would appear to be
problematic for apps that use qwtplot3d. ??
Comment 3 Frank Büttner 2007-05-16 11:04:50 EDT
Yes, the package that shut use this package require qwtplot3d build again Qt4.
This will be submitted soon.
Comment 4 Mamoru TASAKA 2007-06-24 03:16:22 EDT
Would you update the status of this package first?
Comment 5 Frank Büttner 2007-06-24 04:19:30 EDT
I must wait until an reviewer will approve it, so that it can be checked it.
Comment 6 Chitlesh GOORAH 2007-08-08 07:58:10 EDT
Recently, I took over the qwtplot3d package.

I'm planning to ship a qwtplot3d-qt4 package out of qwtplot3d.
Take a look at:
http://chitlesh.fedorapeople.org/result/
and tell me what you think about it, before I commit to cvs.
Ultimately, this bug can be closed once committed to cvs.
Comment 7 Frank Büttner 2007-08-08 13:05:34 EDT
When it is linked again Qt4 all will be ok:)
Comment 8 Chitlesh GOORAH 2007-08-08 13:10:37 EDT
What do you mean ?
Comment 9 Frank Büttner 2007-08-08 13:16:31 EDT
You must build it twice. One time again Qt3 an the second time with Qt4.
Comment 10 Chitlesh GOORAH 2007-08-08 13:23:16 EDT
I did so in the spec file:
http://chitlesh.fedorapeople.org/result/qwtplot3d.spec
Comment 11 Frank Büttner 2007-08-08 13:34:45 EDT
This is not correct, because you must remove all old stuff after build, before
you can built it for Qt4. The easy way is simple copy the sources after extract
to an second directory. Than build it for Qt3 in the original dir, move to the
second and build it for Qt4.
Comment 12 Chitlesh GOORAH 2007-08-08 16:55:11 EDT
I have updated the spec without dumping the release:
http://chitlesh.fedorapeople.org/result/qwtplot3d.spec

the qwtplot3d-qt4 libraries are compiled first and outputs on the qt4 
directory.
Then make clean.
Afterwards qwtplot3d (qt3.3) libraries are compiled.
Comment 13 Chitlesh GOORAH 2007-08-08 16:55:55 EDT
do you want to be the co-packager for qwtplot3d ?
Comment 14 Rex Dieter 2007-08-09 12:31:29 EDT
I'd recommend using macros provided by qt4-devel 
(in /etc/rpm/macros.qt4): %_qt4_headerdir, %_qt4_libdir
(or output from
qmake-qt4 -query QT_INSTALL_HEADERS
qmake-qt4 -query QT_INSTALL_LIBS
respectively).

Comment 15 Frank Büttner 2007-08-09 13:20:40 EDT
Sorry, but I have to less time at now. To be an co-packager for more projects.
Comment 16 Chitlesh GOORAH 2007-08-10 19:07:09 EDT
(In reply to comment #14)
> I'd recommend using macros provided by qt4-devel 
> (in /etc/rpm/macros.qt4): %_qt4_headerdir, %_qt4_libdir
> (or output from
> qmake-qt4 -query QT_INSTALL_HEADERS
> qmake-qt4 -query QT_INSTALL_LIBS
> respectively).

I have updated the spec without dumping the release:
http://chitlesh.fedorapeople.org/result/qwtplot3d.spec
Comment 17 Mamoru TASAKA 2007-08-10 20:57:04 EDT
(In reply to comment #1)
> https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=221163
> 
> * If you have a special reason to use qt4, not qt3, then
>   the most file names should be renamed to avoid conflict
>   of qt3 version qwtplot3d, or explicit conflict must be used.

So again both qwtplot3d and qwtplot3d-qt4 
- install the libraries with the same name 
  "libqwtplot3d.so"
- to different directories, although both directories are under
  ld search path (on i386 one is /usr/lib/qt-3.3/lib, and the other
  is /usr/lib)

So if both qwtplot3d and qwtplot3d-qt4 are installed, one of the
two libraries is always used (according to the order of the ld
search), this is not desirable.
Comment 18 Mamoru TASAKA 2007-08-10 21:00:50 EDT
And why must qwtplot3d-qt4 require qwtplot3d (Qt 3 version)?
Comment 19 Chitlesh GOORAH 2007-08-11 11:57:47 EDT
(In reply to comment #17)
> So if both qwtplot3d and qwtplot3d-qt4 are installed, one of the
> two libraries is always used (according to the order of the ld
> search), this is not desirable.

what do you recommend to do ?
so in this case, we can't use the macros proposed by Rex ?
Comment 20 Mamoru TASAKA 2007-08-11 12:21:50 EDT
(In reply to comment #19)
> (In reply to comment #17)
> > So if both qwtplot3d and qwtplot3d-qt4 are installed, one of the
> > two libraries is always used (according to the order of the ld
> > search), this is not desirable.
> 
> what do you recommend to do ?
> so in this case, we can't use the macros proposed by Rex ?
What I want to say is of no relation with what Rex said
(so you can still use qt4 macros).

So for the case qtwplot3d and qwtplot3d-qt4 are both installed,
- the name of the library in qwtplot3d-qt4 must be renamed
  (to libqwtplot3d-qt4.so, for example)
- Well, IMO we don't have to rename the header files.....

Comment 21 Frank Büttner 2007-08-11 12:25:01 EDT
I thing you shut named it libqwtplot3d-qt3.so and libqwtplot3d-qt4.so to make
the naming clean.
Comment 22 Mamoru TASAKA 2007-08-11 12:36:07 EDT
(In reply to comment #21)
> I thing you shut named it libqwtplot3d-qt3.so and libqwtplot3d-qt4.so to make
> the naming clean.

In that case the trouble is that as Qt3 version qwtplot3d is
already in Fedora and renaming Qt3 version library will cause
problems if there are packages which already use qwtplot3d (I
have not checked if there is). Or we can use symlink like:

libqwtplot3d.so -> libqwtplot3d-qt3.so
Comment 23 Rex Dieter 2007-08-11 13:33:10 EDT
The lib-soname issue here should be taken upstream.  They should at least be
made aware of this problem, and ultimately, their problem to address.
Comment 24 Chitlesh GOORAH 2007-08-13 19:09:34 EDT
I have updated the spec without dumping the release:
http://chitlesh.fedorapeople.org/result/qwtplot3d.spec

upstream will be contacted.
Comment 25 Mamoru TASAKA 2007-08-14 12:05:16 EDT
-------------------------------------------------
cd qt4
%{__mkdir} -p %{buildroot}%{_qt4_libdir}
%{__install} -p -m 0755 lib/libqwtplot3d.so.* %{buildroot}%{_qt4_libdir}
ln -s libqwtplot3d.so.%{version} %{buildroot}%{_qt4_libdir}/libqwtplot3d-qt4.so
-------------------------------------------------

This does not solve the problem I mentioned. Qt4 libqwtplot3d.so
must be renamed (and would you also provide the new srpm?)
Comment 26 Rex Dieter 2007-08-14 12:17:05 EDT
Right, each lib (qt3 vs qt4 one) needs to have a unique soname.
Comment 28 Mamoru TASAKA 2007-08-26 02:24:43 EDT
Well, for -3:

--------------------------------------------------------------
[tasaka1@localhost qwtplot3d]$ LANG=C rpm -qlpv
qwtplot3d-qt4-0.2.7-3.fc8.i386.rpm | sed -e 's|^.*root||'
               21 Aug 26 02:23 /usr/lib/libqwtplot3d-qt4.so.0 ->
libqwtplot3d.so.0.2.7
           350552 Aug 26 02:23 /usr/lib/libqwtplot3d-qt4.so.0.2
           350552 Aug 26 02:23 /usr/lib/libqwtplot3d-qt4.so.0.2.7
                0 Aug 26 02:23 /usr/share/doc/qwtplot3d-qt4-0.2.7
              939 Aug 26 02:22 /usr/share/doc/qwtplot3d-qt4-0.2.7/COPYING
--------------------------------------------------------------
  - libqwtplot3d-qt4.so.0 must point to libqwtplot3d-qt4.so.0.2.7
  - libqwtplot3d-qt4.so.0.2 must be a symlink.

  * And please change license tag.
Comment 29 Chitlesh GOORAH 2007-08-26 19:55:03 EDT
Corrected and committed to rawhide.

Build: http://koji.fedoraproject.org/koji/taskinfo?taskID=130729

I'm therefore closing this bug.

Note You need to log in before you can comment on or make changes to this bug.